# PHP+fis3项目

## 介绍

项目php渲染页面，前端通过seajs引入对应js，library.js在初始化的时候定义添加data-href属性的html元素（当前域链接）绑定单页跳转

## 仓库

svn://dev.webdev.ouj.com/php/trunk

## 技术栈
fis3,seajs,jquery

### 项目结构

示例: 27l/27l_pc

```Text
|- protected
    |- assets                       --- 前端资源
        |- arale                    --- LegoUI提供基础seajs的一些基础插件（可引用）
        |- fonts                    --- 字体资源
        |- img                      --- 图片资源
        |- js                       --- 业务js
            |- libs                     --- 常用库
                |- library.js           --- 主要项目库&封装暴露通用方法(控制页面路由,将页面改造为单页面应用)
                |- seajs.utils.js       --- seajs配置文件
            |- 其他                      --- 页面对应逻辑
        |- sass                     --- css资源
        |- tpl                      --- 模板资源
        |- widget                   --- 封装独立的业务插件（自己写|引用）
        |- dev-watch.md             --- 项目运行编译脚本-window
        |- dev-watch.sh
        |- fis-conf.js              --- fis配置文件
    |- views                        --- 页面视图（访问页面由controller指向）
    |- 其他                         --- php相关
|- static                           --- 最终编译打包资源目录
```

**注意** 

① 某些项目类似云玩一些公共js被提取到公共服务器了，不在项目单独重复引用  

② html元素添加data-href属性为单页跳转，具体看libs/library.js

![avatar](../image/cms52.png)

## 本地开发
①配置内网开发环境（[点击参考](./dev.md)），指向当前项目  

②点击dev-watch运行脚本，或者执行fis3 release dev -d ../../static -w

[![avatar](../image/cms31.png)](../image/cms31.png)  

③所有asset文件都会编译到外层static目录下

④改完提交svn,然后到发布器系统发布到测试环境，预发布环境，测试ok再发布正式环境，正式环境发布前要问下代码可不可以全部发布！！！（因为涉及到后端代码）

## 运营手动内容-模板了解
[详细点击查看](./module.md)

## 项目
### 云玩游戏/微剧院       
[详细点击查看](./yun.md)


### 积分商城  
[详细点击查看](./shop.md)

### 27l   
开发人员：贤达，百醇   

仓库地址：svn://dev.webdev.ouj.com/php/trunk/27l   

发布地址：http://dev.webdev.ouj.com/index.php?r=task/index&project_id=168

访问地址：

>pc&h5：https://www.27l.com/   
>开发者中心：https://open.27l.com/

**注意**：PC,h5响应式适配同个链接,avalon mvvn,jquery

### 多玩手游  
开发人员：贤达，百醇，罗广

仓库地址：svn://dev.webdev.ouj.com/php/trunk/sy     

发布地址：http://dev.webdev.ouj.com/index.php?r=task/index&project_id=108

访问地址：  
>pc: http://sy.duowan.com/  
>h5: http://sy.duowan.cn/    
>开发者平台：http://sy.duowan.com/developer/

### 多玩特权
开发人员：文兵，贤达，志鸿，冯罡，罗广  

仓库地址：svn://dev.webdev.ouj.com/php/trunk/ka  

发布地址：http://dev.webdev.ouj.com/index.php?r=task/index&project_id=70

访问地址：
>pc: http://ka.duowan.com/  
>h5: https://mka.duowan.com/
>小程序: 微信搜索 `多玩特权礼包`

### Hi运动
开发人员：文兵，贤达，俊强，百醇

仓库地址：svn://dev.webdev.ouj.com/php/trunk/hiyd    

发布地址：http://dev.webdev.ouj.com/index.php?r=task/index&project_id=63

访问地址：  
>pc: https://www.hiyd.com/  
>h5: https://m.hiyd.com/

### 多玩单机H5 
开发人员：贤达，百醇 

仓库地址：svn://dev.webdev.ouj.com/php/trunk/steam

发布地址： 

访问地址：http://pc.duowan.cn/ 

  
